Summary: SmartCard library and applications.
Name: opensc
Version: 0.9.6
Release: beta7
License: GPL
Group: Applications/System
URL: http://www.opensc.org/
Source:    opensc-20050502.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires:	openssl libldap2

%description
libopensc is a library for accessing SmartCard devices. It is also the
core library of the OpenSC project.

Basic functionality (e.g. SELECT FILE, READ BINARY) should work on any
ISO 7816-4 compatible SmartCard. Encryption and decryption using
private keys on the SmartCard is possible with PKCS #15 compatible
cards, such as the FINEID (Finnish Electronic IDentity) card.

%define pamdir /lib/security

%prep
%setup -q -n opensc-20050502

%build
%configure --prefix=/usr --with-pam --enable-debug
make

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

cd %{buildroot}
mkdir -p lib/security
mv usr/lib/security/pam_opensc.so lib/security
rm -rf usr/lib/security


%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc ANNOUNCE README* AUTHORS ChangeLog COPYING NEWS docs/*
%{_bindir}/cardos-info
%{_bindir}/cryptoflex-tool
%{_bindir}/opensc-config
%{_bindir}/opensc-explorer
%{_bindir}/opensc-tool
%{_bindir}/pkcs11-tool
%{_bindir}/pkcs15-crypt
%{_bindir}/pkcs15-init
%{_bindir}/pkcs15-tool
%{_bindir}/eidenv
%{pamdir}/pam_*
%{_mandir}/man1/*.1*
%{_mandir}/man3/*.3*
%{_mandir}/man5/*.5*
%{_mandir}/man7/*.7*
%{_datadir}/opensc
%{_includedir}/opensc*
%{_libdir}/*
%{_libdir}/pkgconfig/libopensc.pc
