/*
 * The Cryptonit security software suite is developped by IDEALX
 * Cryptonit Team (http://IDEALX.org/ and http://cryptonit.org).
 *
 * Copyright ? 2003 IDEALX
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef _KEY_STORE_HH_
#define _KEY_STORE_HH_

#define GETKEY_SUCCESS 0
#define GETKEY_CANCELED 1
#define GETKEY_INVALID  2
#define GETKEY_BAD_PASSWD 3

#include "pkcs12.hh"
#include "PasswordManager.hh"

namespace Cryptonit {
    /***
     * virtual class for Key Store
     */
    class KeyStore
    {
    public:
	/* Get the list of Certificates
	 * @return a vector of Certificate
	 */
	virtual  std::vector<Certificate> listCertificates()
	{
	    return std::vector<Certificate>(0);
	}

	/** Get the Key corresponding to the given certificate.
	 * Must return one of GETKEY_SUCCESS, GETKEY_CANCELED, GETKEY_INVALID, GETKEY_BAD_PASSWD
	 */
	virtual int getKey(Certificate c, Key **k)
	{
	    return 0 ;
	}

	void setPasswordManager(PasswordManager *m)
	{
	    return ;
	}

	virtual int getType(){
	    return -1;
	}
	
	virtual int removeKey( const size_t index , std::string &ret, const std::string password = "") 
	{
		return 0;
	}

    };

    enum {
	SOFT_KEYSTORE,
	PKCS11_KEYSTORE
    };

}

#endif
