/*
 * The Cryptonit security software suite is developped by IDEALX
 * Cryptonit Team (http://IDEALX.org/ and http://cryptonit.org).
 *
 * Copyright ? 2003 IDEALX
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */


#ifndef _env_hh
#define _env_hh

#include "error.hh"

/**
 * some macros for debug information
 */ 
#define __DEBUG

#ifdef __DEBUG
#define DEBUG_(x) x
#define DEBUG_ERROR(msg) fprintf(stderr, "Error at line : %d in %s\n\t%s\n", __LINE__, __FILE__, msg); fflush(stderr);
#define DEBUG_MSG(msg) fprintf(stderr, msg); fflush(stderr);
#define DEBUG_MSG_LONG(str, var) fprintf(stderr, str, var); fflush(stderr);
#define DEBUG_OUT(file) fclose(stderr); stderr = fopen(file, "w");
#else
#define DEBUG_(x) 
#define DEBUG_ERROR(msg) 
#define DEBUG_MSG(msg) 
#define DEBUG_OUT(file)
#endif


namespace Cryptonit{

#undef NO_ERROR


  /** Different file formats recognized
   */
  typedef enum 
  {
      auto_format,
      pem_format,
      der_format,
      pkcs7_der_format,
      pkcs7_pem_format,
      pkcs12_format
  } FileFormat;
  
}
#endif
