/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include <qobject.h>

#include <qmessagebox.h>
#include <qdir.h>
#include <qfile.h>
#include <qurl.h>

#include <qfiledialog.h>
#include "Utils.hh"
#include "User.hh"
#include "pkcs8.hh"
#include "pkcs10.hh"

using namespace Cryptonit;


void CertificateRequestWizard::init(Cryptonit::User* u)
{
  user = u;

  ciphers = getAllCiphers();
  std::vector< std::pair < std::string, std::string > >::iterator it;
  unsigned int i = 0;
  for( it = ciphers.begin(); it != ciphers.end(); it++, i++ )
  {
    cbCipher->insertItem(it->first.c_str());
  }

  cbCipher->setCurrentItem(0);
}

bool CertificateRequestWizard::userPageChanging()
{
  if(tcFirstname->text().isEmpty())
  {
    QMessageBox::critical(this, "Erro", "Voc deve informar pelo menos o primeiro nome.");
    return true;
  }
  else
  {
    personalInfos.clear();

    std::pair< std::pair< std::string, std::string >, std::string > entry;

    if( !tcFirstname->text().isEmpty())
    {
      entry.second = tcFirstname->text().latin1();
      entry.first.first = "commonName";
      entry.first.second = "First name";//i18n
      personalInfos.push_back(entry);
    }
    if( !tcLastname->text().isEmpty())
    {
      entry.second = tcLastname->text().latin1();
      entry.first.first = "sn";
      entry.first.second = "Last name";//i18n
      personalInfos.push_back(entry);
    }
    if( !tcTitle->text().isEmpty())
    {
      entry.second = tcTitle->text().latin1();
      entry.first.first = "title";
      entry.first.second = "Title";//i18n
      personalInfos.push_back(entry);
    }
    if( !tcDisplayname->text().isEmpty())
    {
      entry.second = tcDisplayname->text().latin1();
      entry.first.first = "name";
      entry.first.second = "Display name";//i18n
      personalInfos.push_back(entry);
    }
    if( !tcNickname->text().isEmpty())
    {
      entry.second = tcNickname->text().latin1();
      entry.first.first = "givenName";
      entry.first.second = "Nickname";//i18n
      personalInfos.push_back(entry);
    }
    if( !tcEmail->text().isEmpty())
    {
      entry.second = tcEmail->text().latin1();
      entry.first.first = "emailAddress";
      entry.first.second = "Email";//i18n
      personalInfos.push_back(entry);
    }
    if( !tcEmail2->text().isEmpty())
    {
      entry.second = tcEmail2->text().latin1();
      entry.first.first = "mail2";
      entry.first.second = "Additionnal Email";//i18n
      personalInfos.push_back(entry);
    }
    if( !tcScreenname->text().isEmpty())
    {
      entry.second = tcScreenname->text().latin1();
      entry.first.first = "displayName";
      entry.first.second = "Screen Name";//i18n
      personalInfos.push_back(entry);
    }
  }

  return false;
}

bool CertificateRequestWizard::organizationPageChanging()
{
  std::pair< std::pair< std::string, std::string >, std::string > entry;
  organizationInfos.clear();

  if( !tcOrganization->text().isEmpty())
  {
    entry.second = tcOrganization->text().latin1();
    entry.first.first = "organizationName";
    entry.first.second = "Organization";//i18n
    organizationInfos.push_back(entry);
  }
  if( !tcDepartment->text().isEmpty())
  {
    entry.second = tcDepartment->text().latin1();
    entry.first.first = "organizationalUnitName";
    entry.first.second = "Department";//i18n
    organizationInfos.push_back(entry);
  }
  if( !tcAddress->text().isEmpty())
  {
    entry.second = tcAddress->text().latin1();
    entry.first.first = "street";
    entry.first.second = "Address";//i18n
    organizationInfos.push_back(entry);
  }
  if( !tcAddress2->text().isEmpty())
  {
    entry.second = tcAddress2->text().latin1();
    entry.first.first = "street2";
    entry.first.second = "";
    organizationInfos.push_back(entry);
  }
  if( !tcCity->text().isEmpty())
  {
    entry.second = tcCity->text().latin1();
    entry.first.first = "localityName";
    entry.first.second = "City";//i18n
    organizationInfos.push_back(entry);
  }
  if( !tcState->text().isEmpty())
  {
    entry.second = tcState->text().latin1();
    entry.first.first = "stateOrProvinceName";
    entry.first.second = "State/Province";//i18n
    organizationInfos.push_back(entry);
  }
  if( !tcZip->text().isEmpty())
  {
    entry.second = tcZip->text().latin1();
    entry.first.first = "postalCode";
    entry.first.second = "Zip/Postal Code";//i18n
    organizationInfos.push_back(entry);
  }
  if( !tcCountry->text().isEmpty())
  {
    entry.second = tcCountry->text().latin1();
    entry.first.first = "countryName";
    entry.first.second = "Country";//i18n
    organizationInfos.push_back(entry);
  }
  if( !tcWebpage->text().isEmpty())
  {
    entry.second = tcWebpage->text().latin1();
    entry.first.first = "www";
    entry.first.second = "Web Page"; //i18n
    organizationInfos.push_back(entry);
  }

  return false;
}

bool CertificateRequestWizard::challengePageChanging()
{
  return false;
}

bool CertificateRequestWizard::privateKeyPageChanging()
{
  if(tcPassphrase->text().isEmpty())
  {
    QMessageBox::critical(this, "Erro", "Voc deve fornecer uma senha para sua chave privada.");
    return true;
  }
  else if ( tcKeySize->text().isEmpty()
            || tcKeySize->value() == 0)
  {
    QMessageBox::critical(this, "Erro", "Voc deve fornecer um tamanho de chave vlido para sua chave privada.");
    return true;
  }
  else if ( tcPassphraseFirst->text() != tcPassphrase->text() )
  {
    QMessageBox::critical(this, "Erro", "Sua senha est incorreta.");
    return true;
  }
  else
  {
    passphrase = tcPassphrase->text();
    algorithm = ciphers[ cbCipher->currentItem() ].second.c_str();
    prettyAlgorithm = ciphers[ cbCipher->currentItem() ].first.c_str();
    keySize = tcKeySize->value();
  }

  return false;
}

bool CertificateRequestWizard::requestFilePageChanging()
{
  if(tcFilename->text().isEmpty())
  {
    QMessageBox::critical(this, "Error", "Voc deve fornecer um arquivo para sua chave privada.");
    return true;
  }
  else
  {
    filename = tcFilename->text();
  }

  return false;
}

void CertificateRequestWizard::populateSumary()
{
  lbFirstName->setText(tcFirstname->text());
  lbLastName->setText(tcLastname->text());
  lbOrganization->setText(tcOrganization->text());
  lbDepartment->setText(tcDepartment->text());
  lbKeySize->setText(tcKeySize->text());
  lbCipher->setText(cbCipher->currentText());
  lblRequestFileInfo->setText(tcFilename->text());
}

void CertificateRequestWizard::next()
{
  bool hasError = FALSE;

  QWidget *page = QWizard::currentPage();

  if(page == userPage)
  {
    hasError = userPageChanging();
  }
  else if (page == organizationPage)
  {
    hasError = organizationPageChanging();
  }
  else if(page == challengePage)
  {
    hasError = challengePageChanging();
  }
  else if(page == privateKeyPage)
  {
    hasError = privateKeyPageChanging();
  }
  else if(page == requestFilePage)
  {
    hasError = requestFilePageChanging();

    if(!hasError)
    {
      populateSumary();
    }
  }

  if (!hasError)
  {
    QWizard::next();
  }
}

bool CertificateRequestWizard::getSuccess()
{
  int ret = exec();
  if(ret == QDialog::Accepted)
  {
    return true;
  }
  else
  {
    return false;
  }
}


void CertificateRequestWizard::slotPhraseKeyDown( const QString & )
{
  if(tcPassphrase->text() != tcPassphraseFirst->text())
  {
    lbPhraseMatch->setText("Senhas no coinscidem");
  }
  else
  {
    lbPhraseMatch->setText("Senhas coinscidem");
  }
}


void CertificateRequestWizard::slotOpenFile()
{
  QString path = QFileDialog::getSaveFileName(QDir::homeDirPath(), "PEM (*.pem)", this,
                 0, "Escolha um destino para a requisio de certificado");

  QString ext = path.section( '.', -1 );
  if(ext != "pem")
  {
    path += ".pem";
  }
  tcFilename->setText(path);
}


void CertificateRequestWizard::slotSelected( const QString &)
{
  if(ProcessPage->name() == QWizard::currentPage()->name())
  {
    doProcess();
  }
}


void CertificateRequestWizard::doProcess()
{
  repaint();

  /** Prime p **/

  Cryptonit::pkcs8 key;
  QString errorMsg;

  int ret = key.generateKeyPair( tcKeySize->value(), generateKeyCallback, 0L);
  switch( ret )
  {
  case -1: errorMsg = "No foi possvel obter o gerador de nmero aleatrio.";
    break;
  case -2: errorMsg = "O par de chaves gerado  invlido e deve ser gerado novamente.";
    break;
  case -3: errorMsg = "Ocorreu um erro ao realizar testes com a chave gerada.";
    break;
  case -4: errorMsg = "No foi possvel associar a chave gerada ao objeto PKCS#8 atual.";
    break;
  }

  if(!errorMsg.isEmpty())
  {
    QMessageBox::critical(this, "Erro", errorMsg);
    //     generated = false;
    return;
  }

  //   lbPrimeQIcon->show();

  /** Encrypting key **/
  //   lbCryptKeyIcon->show();

  QString buffer;
  buffer = user->getHome().c_str();
  buffer += "/";
  buffer += P12_PATH;
  buffer += "/id_";
  buffer += cbCipher->currentText().latin1();
  //   QUrl prefixP12(buffer);

  //   QUrl privateKeyFilename(buffer);
  //   QUrl privateKeyFilename;
  //   QFile privateKeyFile(privateKeyFilename);
  //   privateKeyFilename.AssignTempFileName( prefixP12.GetFullPath(), privateKeyFile );
  QFile id(buffer);
  if( key.save( buffer.latin1(),
                getCipher(cbCipher->currentText().latin1()),
                tcPassphrase->text().latin1() ) != 0)
  {
    QString msg;
    msg += "No foi possvel gravar sua chave privada no disco: ";
    msg += buffer;
    QMessageBox::critical( this, "Erro", msg);
    //         generated = false;
    return;
  }

  /** Generate PKCS10 **/
  std::vector< std::pair< std::string, std::string > > infos;

  std::vector< std::pair< std::pair< std::string, std::string >, std::string > >::iterator it;

  for( it = personalInfos.begin(); it != personalInfos.end(); it ++ )
  {
    std::pair<std::string, std::string> entry;
    entry.first = it->first.first;
    entry.second = it->second;
    infos.push_back( entry );
  }

  for( it = organizationInfos.begin(); it != organizationInfos.end(); it ++ )
  {
    std::pair<std::string, std::string> entry;
    entry.first = it->first.first;
    entry.second = it->second;
    infos.push_back( entry );
  }

  pkcs10 request( buffer.latin1(), //privateKeyFilename.GetFullPath(),
                  tcPassphrase->text().latin1(),
                  infos);
  if( request.write( tcFilename->text().latin1() ) != 0 )
  {
    QString msg;
    msg = "No foi possvel gravar requisio de certificado no disco: ";
    msg += tcFilename->text();
    QMessageBox::critical( this, "Erro", msg);
  }

  /* Make a copy of the request in the P12/ directory */
//   QUrl requestFilename(buffer);
//   wxFileName requestFilename( privateKeyFilename );
  //requestFilename.SetExt( "p10" );
  buffer += ".p10";
    
  QFile req(buffer);
  req.open(IO_WriteOnly);
  req.close();
  
  if( request.write( buffer ) != 0 ) {
    QString msg;
    msg = "No foi possvel gravar a requisio de certificado no disco: ";
    msg += buffer;
    QMessageBox::critical( this , "Erro", msg);
  }

  lbCertLocation->setText(QString("A requisio de certificado se encontra em: ") + tcFilename->text());
   
//   setCancelEnabled( ProcessPage, FALSE );
  cancelButton()->setEnabled(false);
  setFinishEnabled( ProcessPage, TRUE );
}

void CertificateRequestWizard::generateKeyCallback(int /*p*/, int /*n*/, void* /*arg*/)
{
  //   std::cout << "p: " << p << ", n: " << n << std::endl;
}
