/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include "User.hh"
#include "Utils.hh"
#include "Pkcs12Dlg.h"
#include "pkcs12.hh"
#include "AddCrlDlg.h"

#include "CertificateRequestWizard.h"
#include "TokenKeySelectionDlg.h"

using namespace Cryptonit;

bool NewUserWizard::loginNamePageChanging()
{
  //   QTextCodec *codec = QTextCodec::codecForName("utf-8");
  bool hasError = FALSE;
  if( tcLoginName->text() == "" || tcPassword->text() == "" )
  {
    hasError = TRUE;
    QString msg = "";
    QString msgEnd = " vlido.";
    if( tcLoginName->text() == "" )
    {
      msg = "Voc deve prover um nome de usurio";
    }
    if( tcPassword->text() == "" )
    {
      if( msg != "" )
      {
        msg+= " e uma senha";
        msgEnd = " vlidos.";
      }
      else
      {
        msg = "Voc deve prover uma senha";
        msgEnd = " vlida.";
      }
    }
    QMessageBox::critical(this, "Erro", msg+msgEnd);
  }
  //O cdigo abaixo deve ser testado no KDeveloper.

  else if ( (tcLoginName->text() != "") && (tcPassword->text() != "")
            && User::isUserValid(tcLoginName->text().latin1()) )
  {
    hasError = TRUE;
    QMessageBox::critical(this, "Erro", "Este usurio j existe");
  }

  return hasError;
}

bool NewUserWizard::importMethodPageChanging()
{
  User *user = new User();

  if(userName.length() > 0)
  {
    User user = User(userName);
    user.remove();
  }

  // Import from a PKCS#12 file
  if(rbPkcs12->isOn())
  {

    Pkcs12Dlg p12dlg(this);
    p12dlg.init(true);
    int k = p12dlg.exec();
    if( k == QDialog::Accepted )
    {
      // Create preliminary user files and directories

      if ( ! NewUserWizard::createUserFiles(tcLoginName->text().latin1(),
                                            tcPassword->text().latin1(),
                                            cbLanguage->text(cbLanguage->currentItem()).latin1()) )
      {
        return true;
      }

      method = _private::PKCS12;

      if(p12dlg.getPkcs12Filename().isEmpty())
      {
        filename = new std::string;
      }
      else
      {
        filename = new std::string(p12dlg.getPkcs12Filename().latin1());
      }

      int res;
      QString errorMsg;

      QString IDName = p12dlg.getIdentity();
      if( IDName.isEmpty())
        IDName = "Default";

      identity =  new std::string(IDName.latin1());
      // Reload the User with the updated values
      user = new User( tcLoginName->text().latin1() );

      // Add identity to th user from the PKCS 12
      res = user->addIdentityFromP12( identity->c_str(),
                                      p12dlg.getPkcs12Filename().latin1(),
                                      p12dlg.getPkcs12Password().latin1() );

      //delete user;

      switch( res )
      {
      case 0:
        break;
      case -1: errorMsg = "No foi possvel carregar o PKCS#12.";
        break;
      case -2: errorMsg = "Este arquivo PKCS#12 j existe para esse usurio.";
        break;
      case -3: errorMsg = "Essa identidade j se encontra na lista, por favor utilize um nome diferente.";
        break;
      case -4: errorMsg = "Ocorreu um erro ao gravar certificado no disco.";
        break;
      case -5: errorMsg = "No foi possvel adicionar as informaes de identidade na lista de contatos.";
        break;
        case -6: errorMsg = "No foi possvel gravar em disco um certificado CA includo no PKCS#12.";
        break;
      case -7: errorMsg = "No foi possvel copiar o PKCS#12 no diretrio de usurio.";
        break;
      default: errorMsg = "Erro desconhecido.";
        break;
      }

      if(!errorMsg.isEmpty())
      {
        QMessageBox::critical(this, "Erro", errorMsg);
        return true;
      }


      pkcs12 p12;
      Certificate cert;
      p12.load( p12dlg.getPkcs12Filename().latin1(), p12dlg.getPkcs12Password().latin1() );
      cert = p12.getCertificate();
      //downloading CRL for this p12 certificate and CA
      //CA
      std::vector<Certificate> CA;
      std::vector<Certificate>::iterator it;
      CA = p12.getCA();
      for( it = CA.begin(); it != CA.end(); it++ )
      {
        std::string uri = it->extractCrlUri();
        if( uri != "" )
        {
          QString newCrlFile = AddCrlDlg::fetchCrl( uri.c_str() );
          Crl newCrl;
          if( newCrl.load( newCrlFile.latin1()) == Cryptonit::SUCCESS )
          {
            Cryptonit::Certificate newCert( *it );
            AddCrlDlg::saveCrl( uri.c_str() , &newCrl , newCert , user );
          }
        }
      }
      //certificate
      std::string uri = cert.extractCrlUri();
      if( uri != "")
      {
        QString newCrlFile = AddCrlDlg::fetchCrl( uri.c_str() );
        Cryptonit::Crl newCrl;
        if( newCrl.load( newCrlFile.latin1()) == Cryptonit::SUCCESS )
        {
          AddCrlDlg::saveCrl( uri.c_str() , &newCrl , cert , user );
        }
      }

    }
    else
    {
      //cancel clicked: do nothing
      return true;
    }
  }
  // Certificate request
  else if( rbCertificateRequest->isOn())
  {
    method = _private::REQUEST;
    if ( ! NewUserWizard::createUserFiles(tcLoginName->text().latin1(),
                                          tcPassword->text().latin1(),
                                          cbLanguage->text(cbLanguage->currentItem()).latin1()) )
    {
      return true;
    }

    // Reload the User with the updated values
    user = new User( tcLoginName->text().latin1() );

    // Launch the CertificateRequestWizard
    CertificateRequestWizard* wizi = new CertificateRequestWizard(this );
    wizi->init( user );
    if( !wizi->getSuccess() )
    {
      delete wizi;      
      user->remove();      
      return true;
    }
    delete wizi;
  }
  // Blank account
  else if ( blankAccount->isOn())
  {
    method = _private::BLANK;
    if ( ! NewUserWizard::createUserFiles(tcLoginName->text().latin1(),
                                          tcPassword->text().latin1(),
                                          cbLanguage->text(cbLanguage->currentItem()).latin1()) )
    {
      return true;
    }

    // Reload the User with the updated values
    user = new User( tcLoginName->text().latin1() );

  }
  //Importar a partir do token
  else if (rbToken->isOn())
  {
    tokenKeySelectionDlg *tkKeySelectionDlg = new tokenKeySelectionDlg(this);
    if( tkKeySelectionDlg->exec() == QDialog::Accepted )
    {
      // Create preliminary user files and directories
      if ( ! NewUserWizard::createUserFiles(tcLoginName->text().latin1(),
                                            tcPassword->text().latin1(),
                                            cbLanguage->text(cbLanguage->currentItem()).latin1()) )
      {
        return true;
      }

      method = _private::TOKEN;

      int res;
      QString errorMsg;

      QString IDName = tkKeySelectionDlg->getIdentity();
      if( IDName.isEmpty())
        IDName = "Default";

      identity =  new std::string(IDName.latin1());
      // Reload the User with the updated values
      user = new User( tcLoginName->text().latin1() );
      Certificate *cert = tkKeySelectionDlg->getCertificate();
      std::vector<Cryptonit::Certificate> *certChain = tkKeySelectionDlg->getChain();
      // Add identity to th user from the PKCS 12
      res = user->addIdentityFromToken( identity->c_str(),
                                      tkKeySelectionDlg->getKeyId(),
                                      *cert,
				      certChain);

      //delete user;
      //downloading CRL for this p12 certificate and CA
      //CA
      std::vector<Certificate> CA;
      std::vector<Certificate>::iterator it;
      for( it = certChain->begin(); it != certChain->end(); it++ )
      {
        std::string uri = it->extractCrlUri();
        if( uri != "" )
        {
          QString newCrlFile = AddCrlDlg::fetchCrl( uri.c_str() );
          Crl newCrl;
          if( newCrl.load( newCrlFile.latin1()) == Cryptonit::SUCCESS )
          {
            Cryptonit::Certificate newCert( *it );
            AddCrlDlg::saveCrl( uri.c_str() , &newCrl , newCert , user );
          }
        }
      }
      //certificate
      std::string uri = cert->extractCrlUri();
      if( uri != "")
      {
        QString newCrlFile = AddCrlDlg::fetchCrl( uri.c_str() );
        Cryptonit::Crl newCrl;
        if( newCrl.load( newCrlFile.latin1()) == Cryptonit::SUCCESS )
        {
          AddCrlDlg::saveCrl( uri.c_str() , &newCrl , *cert , user );
        }
      }
      
      
      
      switch( res )
      {
      case 0:
        break;
      case -1: errorMsg = "No foi possvel carregar o PKCS#12.";
        break;
      case -2: errorMsg = "Este arquivo PKCS#12 j existe para esse usurio.";
        break;
      case -3: errorMsg = "Essa identidade j se encontra na lista, por favor utilize um nome diferente.";
        break;
      case -4: errorMsg = "Ocorreu um erro ao gravar certificado no disco.";
        break;
      case -5: errorMsg = "No foi possvel adicionar as informaes de identidade na lista de contatos.";
        break;
        case -6: errorMsg = "No foi possvel gravar em disco um certificado CA includo no PKCS#12.";
        break;
      case -7: errorMsg = "No foi possvel copiar o PKCS#12 no diretrio de usurio.";
        break;
      default: errorMsg = "Erro desconhecido.";
        break;
      }

      if(!errorMsg.isEmpty())
      {
        QMessageBox::critical(this, "Erro", errorMsg);
        return true;
      }

/*
      //certificate
      std::string uri = cert->extractCrlUri();
      if( uri != "")
      {
        QString newCrlFile = AddCrlDlg::fetchCrl( uri.c_str() );
        Cryptonit::Crl newCrl;
        if( newCrl.load( newCrlFile.latin1()) == Cryptonit::SUCCESS )
        {
          AddCrlDlg::saveCrl( uri.c_str() , &newCrl , *cert , user );
-        }
      }
*/
    }
    else
    {
      //cancel clicked: do nothing
      return true;
    }
  }
  else
  {
    QMessageBox::critical(this, "Erro", "Escolha uma opo.");
    return true;
  }

  // Backup all user's files
  if( user->addressBook != NULL )
  {
    if( ! (user->addressBook->save()) )
    {
      QString msg = "Ocorreu um erro ao gravar a lista de contatos.";
      QMessageBox::critical(this, msg, "Erro");
      return true;
    }
  }

  if( user->authorities != NULL )
  {
    if( ! (user->authorities->save()) )
    {
      QString msg = "Ocorreu um erro ao gravar o banco de dados de autoridades.";
      QMessageBox::critical(this, msg, "Erro");
      return true;
    }
  }

  if( ! (user->saveToFile()) )
  {
    QString msg = "Ocorreu um erro ao gravar as preferncias de usurio.";
    QMessageBox::critical(this, msg, "Erro");
    return true;
  }

  delete user;

  return false;
}

void NewUserWizard::setupSummary()
{
  lblLoginName->setText(userName.c_str());

  switch(method)
  {
  case _private::BLANK:
    lblCreationMethod->setText("Conta em branco criada:");
    lblDescription->setText("Voc pode apenas auto-decriptar e verificar assinaturas."
                            "\nVoc poder, mais tarde, adicionar uma identidade pelo painel de configurao.");
    break;
  case _private::REQUEST:
    lblCreationMethod->setText("Conta criada com requisio de certificado:");
    lblDescription->setText(QString("Voc precisa mandar essa requisio para a autoridade de registro."
                                    "\nNome da identidade: ") + identity->c_str());
    break;
  case _private::PKCS12:
    lblCreationMethod->setText("Criada uma conta a partir de arquivo PKCS #12:");
    lblDescription->setText(QString(filename->c_str()) + "\nNome da identidade: " + identity->c_str());
    break;
  
  case _private::TOKEN:
    lblCreationMethod->setText("Criada uma conta a partir de Token:");
    lblDescription->setText(QString("Identity name: ") + identity->c_str());
    break;
//   default:
//     QMessageBox::critical(this, "Erro", "Erro interno: metodo desconhecido.");
  }
}

void NewUserWizard::next()
{
  bool hasError = FALSE;
  QWidget *page = QWizard::currentPage();
  if (page == LoginName)
  {
    hasError = loginNamePageChanging();
  }
  else if (page == ImportMethod)
  {
    hasError = importMethodPageChanging();
    
    if(!hasError) 
    {
      userName = tcLoginName->text().ascii();      
      setupSummary();
    }    
  }

  if (!hasError)
  {
    QWizard::next();
  }
}

bool NewUserWizard::createUserFiles( std::string login , std::string password, std::string lang )
{
  User *user = new User();
  if( user->create( login.c_str() ) == false )
  {
    QMessageBox::critical(this, "Erro", "No foi possvel criar os arquivos iniciais para este usurio.");
    return false;
  }
  user->setLogin( login.c_str() );
  // Encrypt and store password into the User structure
  char *c;
  c = encryptPassword( password.c_str(), "1", generateSalt() );

  Entry *pass = new Entry();
  pass->append("Password", new Attribute(c, strlen(c), AttributeString));
  user->setUserInfo(pass);

  // Store the choosen language
  user->setInfo( "Language", std::string(lang.c_str()) );

  // Add default values for the addressbook
  std::vector<std::string> fields;
  fields.push_back("cn");
  fields.push_back("mail");
  fields.push_back("sn");
  user->setInfos( "AddressBookFields", fields );

  // Use the same fields for the LDAP import frame
  user->setInfos( "LdapFields", fields );

  // Save on disk the user preferences file
  std::string prefs = appendDir( getCryptonitHome(),
                                 login );
  prefs = appendDir( prefs, PREFERENCES_FILENAME );

  if( user->saveToFile(prefs) == false )
  {
    QMessageBox::critical(this, "Erro", "No foi possvel criar os arquivos iniciais para este usurio.");
    return false;
  }

  return true;

}

std::string NewUserWizard::getNewUserLogin()
{
  return tcLoginName->text().latin1();
}

void NewUserWizard::init()
{
  //   cbCipher
  setFinishEnabled( Summary, TRUE );
}
