#include "crlfetcher.h"

#include <stdlib.h>

#include <qfile.h>
#include <qdir.h>
#include <qurloperator.h>
#include <qnetworkprotocol.h>
#include <qapplication.h>
// #include <qhttp.h>
#include <qnetwork.h>

CRLFetcher::CRLFetcher(const QString& u, QObject *parent, const char *name)
    : QObject(parent, name),
    mStreamStatus(StreamInit),
    mOutputFile(0),
    uri(u)
{
}

CRLFetcher::~CRLFetcher()
{
  clearFile();
}

void CRLFetcher::clearFile()
{
  delete mOutputFile;
  mOutputFile = 0;
}

bool CRLFetcher::doFetch()
{
  qInitNetworkProtocols();
  
  QString current = QDir::currentDirPath();
  mOutputFile = new QFile();

  char temp[] = "/tmp/assinadorXXXXXX";
  int fd = mkstemp(temp);

  mSavedFile = temp;
  if(fd == -1)
  {
    return false;
  }

  QDir::setCurrent("/tmp");
  mOutputFile->setName(&temp[5]);

  if(!mOutputFile->open(IO_WriteOnly))
  {
    QDir::setCurrent(current);    
    return false;
  }

  mStreamStatus = StreamPending;

   QUrlOperator op(uri);
//   QHttp op("http://www.digitrust.com.br");

  connect(&op, SIGNAL(finished ( QNetworkOperation* )),
          this, SLOT(slotFinished(QNetworkOperation*)));
  connect(&op, SIGNAL(data ( const QByteArray&, QNetworkOperation *)),
          this, SLOT(slotData( const QByteArray&, QNetworkOperation*)));

  op.get();
//   op.get("crl/digitrustCRL.crl");

  while(mStreamStatus == StreamPending)
  {
     qApp->processEvents();
  }

  QDir::setCurrent(current);
  
  //QFile removeme(temp);
  //removeme.remove();
  
  if(mStreamStatus == StreamDoneError)
  {
    return false;
  }
  return true;
}

QString CRLFetcher::savedPath()
{
  return mSavedFile;
}

void CRLFetcher::slotData(const QByteArray & data, QNetworkOperation *)
{
  mOutputFile->writeBlock(data);
}

void CRLFetcher::slotFinished(QNetworkOperation * op)
{
//   int a = op->errorCode();
  
  if(op->state() == QNetworkProtocol::StFailed)
  {
    mStreamStatus = StreamDoneError;
    
  }
  else
  {
    mStreamStatus = StreamDone;
  }
}

#include "crlfetcher.moc"
