//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include <qpushbutton.h> 
#include <qlabel.h> 
#include <qlineedit.h>

#include "CertificateViewer.h"

#include "qtpasswordmanager.h"


QTPasswordManager::QTPasswordManager(QWidget* parent, const char* name, bool modal, WFlags fl)
 : PasswordManager(), QTPasswordManagerFormBase(parent, name, modal, fl)
{
	cvBtn->hide();
	cert = NULL;
	user = NULL;
}

void QTPasswordManager::init(User *u) {
	user = u;
}

QTPasswordManager::~QTPasswordManager()
{
}


bool QTPasswordManager::getPassword(std::string token, std::string object,
				  char **password, int flags, Certificate *c){
    cert = c;

    if( flags ){
	std::string label = "Este token est bloqueado:";
	labelText->setText(label);
	tokenText->setText(token);
	passwordField->setEnabled(FALSE);
	cancelBtn->setEnabled(FALSE);
	QTPasswordManagerFormBase::exec();
	return false;
    }


    if ( cert ){
	cvBtn->show();
    } else {
	cvBtn->hide();
    }
    
    if( token != "" ){
	std::string label = "Por favor fornea o PIN para desbloquear este token:";
 labelText->setText( label.c_str() );
 tokenText->setText( token.c_str() );
    } else {
	labelText->setText("");
	tokenText->setText("Por favor fornea a senha da sua chave privada");
    }    
    
    if(QTPasswordManagerFormBase::exec() == QDialog::Accepted){
	*password = (char*) malloc ( sizeof(char) * passwordField->text().length() +1 );
	memset(*password , 0 , passwordField->text().length() + 1);
	strncpy(*password , passwordField->text().latin1(), passwordField->text().length());
	
	passwordField->setText("");
	return true;
    } else { //cancel clicked
	return false;
    }
}

void QTPasswordManager::displayDetails(){
     if(cert){     	
	 CertificateViewer cv(this);
	 cv.init(*cert, user , true);	 
	 cv.exec();
     }
}
