//
// C++ Interface: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef TOKENKEY_H
#define TOKENKEY_H

#include <openssl/evp.h>
#include <openssl/safestack.h>
#include <openssl/engine.h>
#include <string>

#include "Key.hh"

typedef struct pw_cb_data
{
  const void *password;
  const char *prompt_info;
} PW_CB_DATA;


/**
@author 
*/
class TokenKey : public Cryptonit::Key
{
private :
  /* This variable contains an OpenSSL key */
  EVP_PKEY *key;
  ENGINE *e;
  int configure_engine (ENGINE *e, STACK *cmds);
  ENGINE *TokenKey::load_engine (STACK *pre_cmds);

public:
  TokenKey(std::string keyID, std::string password);

  virtual ~TokenKey();

  /**
   *  Free the EVP_PKEY
   */
  void free();
  virtual EVP_PKEY * getPrivateKey();

};

#endif
