//
// C++ Interface: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef TOKENKEYSTORE_H
#define TOKENKEYSTORE_H

#include <KeyStore.hh>
#include <string>
#include <vector>

#include "User.hh"
#include "Certificate.hh"
#include "Key.hh"
#include "KeyStore.hh"
#include "PasswordManager.hh"

using namespace Cryptonit;


static std::vector< std::pair< std::string, Certificate> > tempCerts;

/**
@author 
*/
class TokenKeyStore : public KeyStore
{
private:
  std::vector< std::pair< std::string, Certificate> > keysAndCerts;
  User *user;
  PasswordManager *pm;
  
public:
  TokenKeyStore();
  TokenKeyStore(User *u);

  ~TokenKeyStore();
  
  /** Get the list of Certificates
   * @return a vector of Certificate
   */
  virtual std::vector<Certificate> listCertificates();
  
  virtual int removeKey( const size_t index , std::string &ret, const std::string password = "");


  /** Get the Key corresponding to the given certificate.
   * Must return one of GETKEY_SUCCESS, GETKEY_CANCELED, GETKEY_INVALID, GETKEY_BAD_PASSWD
   */
  int getKey(Certificate c, Key **k);

  void setPasswordManager(PasswordManager *m);

  int getType();
  
  void addPair(Certificate cert, std::string keyID);

  static std::vector< std::string > listKeys(std::string report);
  static Certificate* getCert(std::string keyId);
  static Certificate* decodeCert(std::string keyId, std::string certPEM);
  static std::vector< std::string > listCerts(std::string report);
      
};

#endif
